local Clock = {}
Clock.__index = Clock

local warp = 2.0/60.0
--warp = warp * 10

function Clock:update(dt)
  self.time = self.time + warp*dt

  while #self.events > 0 and self.time > self.events[1][1] do
    self.events[1][2]()
    table.remove(self.events, 1)
  end
end


function Clock:printableTime()
  local t = self.time 
  local h = math.floor(t)
  local m = math.floor(math.fmod(t, 1) * 60)

  return string.format("%02d:%02d", h, m)
end


function Clock:draw()
  G.overlays.clock:draw(
    math.floor(self.time * 60) % #G.overlays.clock.frames
  )
end


function Clock:addEvent(t, f, delta)
  t = t / 60.0
  local t2 = delta and (self.time + t) or t
  self.events[#self.events+1] = {t2, f}
  table.sort(self.events, function(a, b) return a[1] < b[1] end)
end


function newClock()
  return setmetatable({
    time = 8,
    events = {}
  }, Clock)
end
