local EndState = {}
EndState.__index = EndState



local variants = {
  dumb = {
    bg = {255,255,255},
    msg = {
      {1, "You forgot to open the silo doors.", 100, 1, {255, 0, 0}},
      {3, "What were you thinking?", 160, 2},
      {5, "But you didn't cause a nuclear war.", 300, 2},
      {8, "That's good.", 340, 2},
      {12, "TELEMATICS", 540, 2, {255, 0, 0}},
      {13, "made in 48h for Ludum Dare 37 by rnlf", 580, 2},
      {16, "Click to restart", 660, 2}
    },
    n = 1
  },

  mutual = {
    bg = {255,255,255},
    msg = {
      {1, "War.", 100, 1, {255, 0, 0}},
      {3, "War never changes.", 140, 1, {255, 0, 0}},
      {5, "You caused a global thermonuclear war.", 300, 2},
      {8, "The world is fucked.", 340, 2},
      {10, "But at least we get to play Fallout IRL.", 380, 2},
      {12, "TELEMATICS", 540, 2, {255, 0, 0}},
      {13, "made in 48h for Ludum Dare 37 by rnlf", 580, 2},
      {16, "Click to restart", 660, 2}
    },
    n = 2
  },

  onlyPlayer = {
    bg = {255,255,255},
    msg = {
      {1, "You're dead.", 100, 1, {255, 0, 0}},
      {3, "But you didn't kill millions of people.", 160, 2},
      {5, "So you have a clear consience.", 300, 2},
      {8, "At least you would have, if you weren't dead.", 340, 2},
      {10, "But you are.", 380, 2},
      {12, "TELEMATICS", 540, 2, {255, 0, 0}},
      {13, "made in 48h for Ludum Dare 37 by rnlf", 580, 2},
      {16, "Click to restart", 660, 2}
    },
    n = 3
  },

  good = {
    bg = {0,0,0},
    msg = {
      {1, "Your watch is over.", 100, 1, {255, 0, 0}},
      {3, "Nobody died in a nuclear firestorm today.", 160, 2},
      {5, "And that's all thanks to you.", 300, 2},
      {8, "You leave the silo and go home.", 340, 2},
      {10, "Have a nice day.", 380, 2},
      {12, "TELEMATICS", 540, 2, {255, 0, 0}},
      {13, "made in 48h for Ludum Dare 37 by rnlf", 580, 2},
      {16, "Click to restart", 660, 2}
    },
    n = 4

  }
}


function EndState:update(dt)
  self.t = self.t + dt
end


function EndState:draw()
  local fonts = {
    G.infoFont2,
    G.infoFont
  }
  local v = variants[self.variant]
  love.graphics.setBackgroundColor(unpack(v.bg))
  love.graphics.clear()
  if v.bg[1] == 255 then
    love.graphics.setBlendMode("alpha", "premultiplied")
  else
    love.graphics.setBlendMode("alpha", "alphamultiply")
  end
  for i, m in ipairs(v.msg) do
    local t = math.min(math.max(self.t - m[1], 0), 1)*255
    local c = m[5] or {255-v.bg[1],255-v.bg[2],255-v.bg[3]}
    love.graphics.setFont(fonts[m[4]])
    love.graphics.setColor(c[1], c[2], c[3], t)
    love.graphics.printf(m[2], 0, m[3], 1300, "center")
  end

  if self.t > 18 then
    local t = math.min(math.max(self.t - 18, 0), 1)*255
    local c = {255-v.bg[1],255-v.bg[2],255-v.bg[3]}
    love.graphics.setColor(c[1], c[2], c[3],t)
    love.graphics.setFont(fonts[2])
    love.graphics.print("This is ending #" .. v.n .. " of 4", 0, 670)
  end

  love.graphics.setBlendMode("alpha", "alphamultiply")
end


function EndState:mouseMoved()
end


function EndState:mouseReleased()
  G.state = newIntroState()
end


function newEndstate(variant)
  return setmetatable({
    variant = variant,
    t = 0
  }, EndState)
end
