local IntroState = {}
IntroState.__index = IntroState


function IntroState:update(dt)
  if self.running and not self.intro:isPlaying() then
    G.state = newState()
  end
end


function IntroState:draw()
  love.graphics.draw(self.intro)
  if not self.running then
    drawInfo("click to start your work day")
  end
end


function IntroState:mouseReleased(x, y)
  self.running = true
  self.intro:rewind()
  self.intro:play()
  G.sounds.doors:play()
  G.sounds.doors:seek(7)
end



function newIntroState()

  return setmetatable({
    intro = love.graphics.newVideo("data/intro.ogg"),
    running = false
  }, IntroState)
end
