function loadNoiseShader()
  G.noiseShader = love.graphics.newShader [[
    extern number time;
    extern vec2 size;
    extern vec3 col;
    extern vec3 col_add;

    float rand(vec2 co)
    {
      // stolen!
      co.x += fract(time/size.x*1.1);
      co.y += fract(time/size.y*1.1);
      float a = 12.9898;
      float b = 78.233;
      float c = 43758.5453;
      float dt= dot(fract(co.xy) ,vec2(a,b));
      float sn= mod(dt,3.14);
      return fract(sin(sn) * c);
    } 

  
    vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords) {
      float n = 0.07 * (rand(texture_coords) - 0.5);

      return (texture2D(texture, texture_coords)*1.05+n)*vec4(col, 1.0)+vec4(col_add, 0.0);
    }
  ]]

  G.noiseShader:send("size", {1300, 700})
end


